/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: IPoolListener.java 5224 2009-11-08 14:00:33Z gaellalire $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.pool.impl.enhanced.api.listener;

import org.ow2.util.pool.impl.enhanced.api.IWaitControl;


/**
 *
 * @author Gael Lalire
 * @param <E> pool item type
 */
public interface IPoolListener<E> {

    void getMethodCalled(IWaitControl timeout);

    void getMethodReturned(E result, IWaitControl timeout);

    void getMethodFailed(Exception e, IWaitControl timeout);

    void putMethodCalled(E poolItem);

    void putMethodReturned(E poolItem);

    void putMethodFailed(Exception e, E poolItem);

    void removeMethodCalled(E poolItem);

    void removeMethodReturned(E poolItem);

    void removeMethodFailed(Exception e, E poolItem);

    void signalAllWaitersMethodCalled();

    void signalAllWaitersMethodReturned();

    void signalAllWaitersMethodFailed(Exception e);

}
